=== debian/changelog ===
monkey (1.6.9-1) stable; urgency=low

  * Update Monkey release to v1.6.9

 -- Eduardo Silva <eduardo@monkey.io>  Sat, 04 Jun 2016 08:00:00 -0600

monkey (1.6.8-1) stable; urgency=low

  * Update Monkey release to v1.6.8

 -- Eduardo Silva <eduardo@monkey.io>  Wed, 11 Jan 2016 08:00:00 -0600

monkey (1.6.7-1) stable; urgency=low

  * Update Monkey release to v1.6.7

 -- Eduardo Silva <eduardo@monkey.io>  Wed, 30 Dec 2015 22:00:00 -0600

monkey (1.6.6-1) stable; urgency=low

  * Update Monkey release to v1.6.6

 -- Eduardo Silva <eduardo@monkey.io>  Fri, 20 Nov 2015 10:00:00 -0600

monkey (1.6.5-1) stable; urgency=low

  * Update Monkey release to v1.6.5

 -- Eduardo Silva <eduardo@monkey.io>  Thu, 10 Nov 2015 10:00:00 -0600

monkey (1.6.4-1) stable; urgency=low

  * Update Monkey release to v1.6.4

 -- Eduardo Silva <eduardo@monkey.io>  Thu, 26 Oct 2015 10:00:00 -0600

monkey (1.6.3-1) stable; urgency=low

  * Update Monkey release to v1.6.3

 -- Eduardo Silva <eduardo@monkey.io>  Fri, 09 Oct 2015 15:00:00 -0600

monkey (1.6.2-1) stable; urgency=low

  * Update Monkey release to v1.6.2

 -- Eduardo Silva <eduardo@monkey.io>  Sun, 31 Aug 2015 16:00:00 -0600

monkey (1.5.2-1) stable; urgency=low

  * Update Monkey release to v1.5.2

 -- Eduardo Silva <eduardo@monkey.io>  Fri, 18 Jul 2014 09:00:00 -0300

monkey (1.5.1-1) stable; urgency=low

  * Fix configure script parameters

 -- Eduardo Silva <edsiper@gmail.com>  Thu, 29 May 2014 09:00:00 -0300

monkey (1.5.0-1) stable; urgency=low

  * Update Monkey release to v1.5.0

 -- Eduardo Silva <edsiper@gmail.com>  Tue, 29 Apr 2014 09:00:00 -0300

monkey (1.4.0-1) stable; urgency=low

  * Update Monkey release to v1.4.0

 -- Eduardo Silva <edsiper@gmail.com>  Mon, 03 Feb 2013 09:00:00 -0300

monkey (1.3.0-1) stable; urgency=low

  * Update Monkey release to v1.3.0

 -- Eduardo Silva <edsiper@gmail.com>  Thu, 15 Oct 2013 09:00:00 -0300

monkey (1.2.0-1) stable; urgency=low

  * Update Monkey release to v1.2.0

 -- Eduardo Silva <edsiper@gmail.com>  Mon, 29 Apr 2013 10:00:00 -0300

monkey (1.1.1-1) stable; urgency=low

  * Update Monkey release to v1.1.1

 -- Eduardo Silva <edsiper@gmail.com>  Sat, 18 Aug 2012 10:00:00 -0300

monkey (1.1.0-2) stable; urgency=low

  * Add missing cgi plugin

 -- Eduardo Silva <edsiper@gmail.com>  Fri, 17 Aug 2012 12:00:00 -0300

monkey (1.1.0-1) stable; urgency=low

  * Update Monkey release to v1.1.0

 -- Eduardo Silva <edsiper@gmail.com>  Fri, 17 Aug 2012 10:00:00 -0300

monkey (0.32.0-1) unstable; urgency=low

  * Update Monkey release to v0.32.0

 -- Eduardo Silva <edsiper@gmail.com>  Fri, 09 Feb 2012 12:00:00 -0300

monkey (0.31.0-1) unstable; urgency=low

  * Update Monkey release to v0.31.0

 -- Eduardo Silva <edsiper@gmail.com>  Fri, 13 Jan 2012 12:00:00 -0300

monkey (0.21.0-1) unstable; urgency=low

  * Update Monkey release to v0.21.0

 -- Eduardo Silva <edsiper@gmail.com>  Thu, 28 Oct 2011 12:00:00 -0300

monkey (0.20.4-1) unstable; urgency=low

  * Add new monkey-dev package

 -- Eduardo Silva <edsiper@gmail.com>  Thu, 12 Oct 2011 12:00:00 -0300

monkey (0.20.3-1) unstable; urgency=low

  * Initial release

 -- Eduardo Silva <edsiper@gmail.com>  Mon, 10 Oct 2011 22:33:20 -0300
