=== debian/control ===
Source: monkey
Section: httpd
Priority: optional
Maintainer: Eduardo Silva <eduardo@monkey.io>
Build-Depends: debhelper (>= 7.0.50~)
Standards-Version: 3.9.1
Homepage: http://monkey-project.com
Vcs-Git: https://github.com/monkey/monkey.git
Vcs-Browser: https://github.com/monkey/monkey

Package: monkey
Architecture: any
Depends: ${misc:Depends}
Description: Fast and lightweight Web Server for Linux.
 Monkey HTTP Server has been designed to be very scalable with low memory
 and CPU consumption, the perfect solution for embedded environments. It
 also provides a flexible API and plugins interface.

Package: monkey-dev
Architecture: any
Depends: ${misc:Depends}, monkey (= ${binary:Version})
Description: Monkey HTTP Server development files
 This package distributes the C headers files required to perform
 the development of a Monkey plugin. This package is not related to the
 library version of Monkey.
